<?php

// Pre-Beta ToDo:
//   Allow change to setting for users to be able to create customers.






// IPplan v4.20b-BETA
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("../adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once '../menus/lib/PHPLIB.php';
require_once '../menus/lib/layersmenu-common.inc.php';
require_once '../menus/lib/treemenu.inc.php';
require_once("../auth.php");


$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);
$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
myLanguage($HTTP_COOKIE_VARS['ipplanLanguage']);


newhtml($p);
$myWwwPath='../menus/';
$w=myheading($p,"User Manager","");
insert($w, generic("link",array("rel"=>"stylesheet","href"=>"$myWwwPath"."layerstreemenu.css")));
insert($w, generic("link",array("rel"=>"stylesheet","href"=>"$myWwwPath"."layerstreemenu-hidden.css")));
insert($w, script("",array("language"=>"JavaScript","type"=>"text/javascript","src"=> $myWwwPath . 'libjs/layerstreemenu-cookies.js')));

//Make this a stylesheet soon.
insert($w, $t=table(
array(
     "cols"		=>"2",
     "width"		=>"100%",
     "border"		=>"1",
     "cellspacing"	=>"2",
     "margin"		=>"5",
     "frame"		=>"void",
     "rules"		=>"ALL",
     "cellpadding"      =>"5")));


// Create the view and editor containers.  
insert($t,       $view   = cell(array("align"=>"left" ,"width"=>"25%" ,"valign"=>"top")));
insert($t,       $editor1= cell(array("align"=>"left" ,"width"=>"75%" ,"valign"=>"top")));
insert($editor1, $editor = container("div",array("class"=>"usermanager")));


// We just do this once and pass the variable around.
$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));


// 4-5-2005 We need to cut down on memory usage.. Lets look this crap up once!

$grplist=array();
$result=$ds->GetGrps();

while($row=$result->FetchRow()) {
    array_push($grplist,$row["grp"]);
}




// Next we check to see if the POST variables have been sent.
// If so we handle this first.
// For example, if we change the user information,
// we want this to be immediately reflected in the user/group control in
// the left hand part of the screen.

if ($HTTP_POST_VARS) {
        $fe="";
	if ($action == "parsecreateuserform")   {  $fe .= parseCreateUserForm($editor, $ds);     }
	if ($action == "parsecreategroupform")  {  $fe .= parseCreateGroupForm($editor, $ds);     }
	if ($action == "deleteuser") 		{  $fe .= parseDeleteForms($editor, $ds);         }
	if ($action == "deletegroup")		{  $fe .= parseDeleteForms($editor, $ds);         }
	if ($action == "deleteuserfromgroup")	{  $fe .= parseDeleteForms($editor, $ds);         }
	if ($action == "changeuserpw")          {  $fe .= parseChangeUserPassword($editor, $ds);  }
	if ($action == "addusertogroup")        {  $fe .= parseAddUserToGroupForm($editor,$ds);   }
        if ($action == "modifygroup")           {  $fe .= parseModifyGroupForm($editor, $ds);     }
	if ($action == "addgroupboundary")	{  $fe .= parseAddGroupBoundaryForm($editor, $ds);}
}

if ($usersearch != "") {
    $result=&$ds->ds->Execute("SELECT userid, userdescrip
            FROM users
            WHERE userid LIKE ".$ds->ds->qstr("%".$usersearch."%")
            ." OR userdescrip LIKE ".$ds->ds->qstr("%".$usersearch."%"));
    $MENU=".|Search Result\n";

    $count=0;
    while ($row = $result->FetchRow()) {
        $MENU .="..|".$row["userid"]."|".$_SERVER["PHP_SELF"]."?action=usereditform&user=".$row["userid"]."\n";
        $count++;
    }

    if ($count==0) {$MENU .="..|NO MATCHES FOUND.\n";}
}


$result=$ds->GetGrps();
$MENU.=".|All Groups\n";

while($row = $result->FetchRow()) {
    $grp=$row["grp"];
    $grpdesc=$row["grpdescrip"];
    $MENU .= "..|$grp|".$_SERVER["PHP_SELF"]."?action=groupeditform&group=".$row["grp"]."\n";
    $uig=&$ds->ds->Execute("SELECT * from usergrp where `grp`='".$grp."';");
    if (!$uig) continue;

    $cnt=0;
    while($row2 = $uig->FetchRow()) {
        $MENU .= "...|".$row2["userid"]."|".$_SERVER["PHP_SELF"]."?action=usereditform&user=".$row2["userid"]."\n";
        $cnt++;
    }
    if (!$cnt) {
        $MENU .= "...|No users in group\n";
    }
}

$result=&$ds->ds->Execute("SELECT users.userdescrip, users.userid
                        FROM users
                        LEFT JOIN usergrp
                        ON users.userid = usergrp.userid
                        WHERE usergrp.userid IS NULL
                        ORDER BY users.userid");
$MENU.=".|Orphan Users\n";
while($row = $result->FetchRow()) {
	$MENU .="..|".$row["userid"]."|".$_SERVER["PHP_SELF"]."?action=usereditform&user=".$row["userid"]."\n";
}

insert($view, block("<center><b>Current Users/Groups<b></center>"));
insert($view, $cc = container("center"));
insert($cc,anchor($_SERVER["PHP_SELF"]."?action=newuserform",
                  my_("New User")));
insert($cc,block(" | "));
insert($cc,anchor($_SERVER["PHP_SELF"]."?action=newgroupform",
                  my_("New Group")));

insert($view, $cc = container("center"));
insert($cc, $searchform = form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
insert($searchform,input_text(array("name"=>"usersearch",
                    "value"=>"$usersearch",
                    "size"=>"20",
                    "maxlength"=>"40")));

insert($searchform,submit(array("value"=>my_("Search"))));
insert($view, block("Edit Users/Groups<br>"));
insert($view, block("<i>Click on a group or user</i>"));
//insert($editor, block("<h3> fixme: User/Group Editor"));
$mid = new TreeMenu();
$mid->setDirroot('../menus');
$mid->setLibjsdir('../menus/libjs/');
$mid->setImgdir('../menus/menuimages/');
$mid->setImgwww('../menus/menuimages/');
$mid->setIcondir('../menus/menuicons/');
$mid->setIconwww('../menus/menuicons/');
$mid->SetMenuStructureString($MENU);
$mid->setIconsize(16, 16);
$mid->parseStructureForMenu('treemenu1');
//$mid->setSelectedItemByCount('treemenu1', 7);
//$mid->setSelectedItemByUrl('treemenu1', basename(__FILE__));
$mid->newTreeMenu('treemenu1');
insert($view, block($mid->getTreeMenu('treemenu1')));
insert($view, block('<br><br>'));

if ($fe != "") {
    myError($editor,$p,$fe,FALSE);
}

// Ok From here Everything is all set to go.  We've built the tree menu thingy and now we're looking 
// Check for actions passed as a POST.



if ($HTTP_GET_VARS) {
	if ($action == "usereditform" ) { insertEditUserForm($editor,$ds);}
	if ($action == "groupeditform") { insertEditGroupForm($editor,$ds);}
	if ($action == "newuserform")   { insert ($editor, block("<h3>Creating a new User</h3>"  )); insertCreateUserForm($editor,$ds);}
	if ($action == "newgroupform")  { insert ($editor, block("<h3>Creating a new Group</h3>" )); insertCreateGroupForm($editor);}
}
else
{
	insert ($editor, block("&nbsp;"));
}

printhtml($p);


// START FUNCTIONS


function insertCreateGroupForm($w) {
    insert($w, $f = form(array("method"=>"post",
                    "action"=>$_SERVER["PHP_SELF"])));
    insert($f, $con=container("fieldset",array("class"=>"fieldset")));
    insert($con, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Create group")));

    insert($con,hidden(array("name"=>"action","value"=>"parsecreategroupform")));
    insert($con,textbr(my_("Group name:")));

    insert($con,input_text(array("name"=>"grp",
                    "value"=>"$grp",
                    "size"=>"40",
                    "maxlength"=>"40")));

    insert($con,textbrbr(my_("Group description:")));
    insert($con,input_text(array("name"=>"grpdescrip",
                    "value"=>"$grpdescrip",
                    "size"=>"40",
                    "maxlength"=>"80")));
    insert($con, $t=table(array("cols"=>"2","border"=>"0","cellspacing"=>"2","width"=>"100%")));
    insert($t, $c=cell());
    insert($c,textbrbr(my_("Group can create/modify/delete customers?")));
    insert($c,selectbox(array("N"=>my_("No"),
                    "Y"=>my_("Yes")),
                array("name"=>"createcust")));
    insert($t, $c=cell());
    insert($c,textbrbr(my_("Group can view any customers data?")));
    insert($c,selectbox(array("Y"=>my_("Yes"),
                    "N"=>my_("No")),
                array("name"=>"grpview")));

    insert($f,submit(array("value"=>my_("Create group"))));

}


function insertEditUserForm($w,$ds) {
    $user=$_GET["user"];

    $result=&$ds->ds->Execute("SELECT * FROM users WHERE userid=".$ds->ds->qstr($user));
    if ($result) {
        $row=$result->FetchRow();
    }

    insert($w, $t=table(array("cols"=>"2","border"=>"0","cellspacing"=>"2","width"=>"100%")));
    insert($t, $c=cell());
    insert($c ,block("<b>Editing User: $user</b><br>"));
    insert($c, block("<i>Real Name: ".$row["userdescrip"]."</i>"));
    insert($t, $c=cell(array("align"=>"right")));
    insert($c, $f = form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
    insert($f,hidden(array("name"=>"action","value"=>"deleteuser")));
    insert($f,hidden(array("name"=>"user"   ,"value"=>"$user")));
    insert($f,submit(array("value"=>"Delete User $user")));
    insert($w,block("<br>"));

    //insert($w, $pwtable=table(array("cols"=>"1","border"=>"1","cellspacing"=>"2","margin-left"=>"5")));
    //insert($pwtable, $pwcell  =  cell(array("align"=>"left" ,"valgin"=>"top")));
    insert($w, $pwform = form(array("method"=>"post",
                    "action"=>$_SERVER["PHP_SELF"])));

    insert($pwform, $con=container("fieldset",array("class"=>"fieldset")));
    insert($con, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Change Password")));
    insert($con,hidden(array("name"=>"user",
                    "value"=>"$user")));

    insert($con,hidden(array("name"=>"action","value"=>"changeuserpw")));
    insert($con,textbr(my_("New password (case sensitive!):")));
    insert($con,password(array("name"=>"password1",
                    "value"=>"$password1",
                    "size"=>"40",
                    "maxlength"=>"40")));

    insert($con,textbrbr(my_("New password (again):")));
    insert($con,password(array("name"=>"password2",
                    "value"=>"$password2",
                    "size"=>"40",
                    "maxlength"=>"40")));
    insert($con,generic("br"));
    insert($con,submit(array("value"=>my_("Change Password"))));


    // START Add User to Group

    $result2=$ds->GetGrps();


    $lst=array();
    $c=0;
    while($row = $result2->FetchRow()) {
        $col=$row["grp"];
        $lst["$col"]=$row["grp"];
        $c++;
    }

    if ($c==0) {
        insert($w,block("<h3>This User is not member of any groups.</h3>"));
    }
    else {
        insert($w, $f2 = form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
        insert($f2, $con=container("fieldset",array("class"=>"fieldset")));
        insert($con, $legend=container("legend",array("class"=>"legend")));
        insert($legend, text(my_("Add user to group")));

        insert($con,hidden(array("name"=>"action","value"=>"addusertogroup")));
        insert($con,hidden(array("name"=>"userid"   ,"value"=>"$user")));

        insert($con,selectbox($lst,
                    array("name"=>"grp")));

        insert($con,submit(array("value"=>my_("Add User to Group"))));

        // START User Group Listing
        insert($w, block("<br><h3> Group Membership</h3>"));

        insert($w,$t = table(array("cols"=>"2",
                        "class"=>"outputtable")));
        // draw heading
        setdefault("cell",array("class"=>"heading"));
        //insert($t,$c = cell());
        //insert($c,text(my_("Group name")));
        insert($t,$c = cell());
        insert($c,text(my_("Group name")));
        insert($t,$c = cell());
        insert($c,text(my_("Action")));

        $result=&$ds->ds->Execute("SELECT * FROM usergrp WHERE userid=".$ds->ds->qstr($user));


        $lst=array();

        while($row = $result->FetchRow()) {
            $col=$row["grp"];
            $lst["$col"]=$row["grp"];
        }

        if (empty($lst)) {
            insert($t, $c = cell());
            insert($c, block("<b>User is not assigned to any group.</b>"));

        }
        else {
            $icecream=0;
            foreach($lst as $g) {
                setdefault("cell",array("class"=>color_flip_flop()));
                $icecream++;
                insert($t,$c=cell());
                insert($c,block("$g"));
                insert($t,$c=cell());

                insert($c,$f= form(array("name"=>"userkill$icecream","method"=>"post","action"=>$_SERVER["PHP_SELF"]))); 
                insert($f,hidden(array("name"=>"group","value"=>"$g")));
                insert($f,hidden(array("name"=>"action","value"=>"deleteuserfromgroup")));
                insert($f,hidden(array("name"=>"usergrp"   ,"value"=>"$user")));
                insert($f,hidden(array("name"=>"group"   ,"value"=>"$g")));
                //insert($f,submit(array("value"=>"Remove")));
                insert($c,block("<a href='#' onclick='userkill$icecream.submit();'> Remove From Group</a>"));

            }
        }

    }


}

function insertEditGroupForm($w,$ds) {
    $group=$_GET["group"];

    $result=&$ds->ds->Execute("select * from grp");
    $row=$result->FetchRow();
    $grpdescrip=$row["grpdescrip"];
    $createcust=$row["createcust"];
    $grpopt    =$row["grpopt"];

    insert($w, $t=table(array("width"=>"100%","cols"=>"2","border"=>"0","cellspacing"=>"0","valign"=>"middle")));
    insert($t, $c = cell());
    insert ($c, block("<b>Editing Group: $group</b><br>"));
    insert ($c, block("<i> Description: </i>".$grpdescrip));
    insert ($w,generic("br"));
    insert ($t,$c = cell (array("align"=>"right")));

    insert($c, $f = form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
    insert($f,hidden(array("name"=>"action","value"=>"deletegroup")));
    insert($f,hidden(array("name"=>"group"   ,"value"=>"$group")));
    insert($f,submit(array("value"=>"Delete Group $group")));

    // MODIFY GROUP FORM
    insert($w, $f1 = form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
    insert($f1, $con=container("fieldset",array("class"=>"fieldset")));
    insert($con, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Modify group")));

    insert($con,hidden(array("name"=>"grp","value"=>"$group")));
    insert($con,hidden(array("name"=>"action","value"=>"modifygroup")));

    insert($con,textbr(my_("Group description:")));
    insert($con,input_text(array("name"=>"grpdescrip",
                    "value"=>"$grpdescrip",
                    "size"=>"80",
                    "maxlength"=>"80")));
    insert($con,generic("br"));
    insert($con,textbrbr(my_("Group can create/modify/delete customers?")));
    insert($con,selectbox(array("N"=>my_("No"),
                    "Y"=>my_("Yes")),
                array("name"=>"createcust"),
                $createcust));

    insert($con,textbrbr(my_("Group can view any customers data?")));
    // first bit defines view capability
    insert($con,selectbox(array("N"=>my_("No"),
                    "Y"=>my_("Yes")),
                array("name"=>"grpview"),
                $grpopt & 1 ? "Y" : "N" ));


    insert($con,submit(array("value"=>my_("Submit"))));
    insert($con,freset(array("value"=>my_("Clear"))));


    // START Add User Form
    $result1=&$ds->ds->Execute("SELECT userid
            FROM users
            ORDER BY userid");

    $c=0;
    $lst=array();

    while($row = $result1->FetchRow()) {
        $col=$row["userid"];
        $lst["$col"]=$row["userid"];
        $c++; // here
    }



    if ($c == 0) {
        //   myError($w,$p, my_("You first need to create some users!"));
        insert($w,block("<hr><h3> Group has no users.</h3>"));
    }
    else {
        insert($w, $f2 = form(array("name"=>"ENTRY",
                        "method"=>"post",
                        "action"=>$_SERVER["PHP_SELF"])));

        insert($f2, $con=container("fieldset",array("class"=>"fieldset")));
        insert($con, $legend=container("legend",array("class"=>"legend")));
        insert($legend, text(my_("Add user to group")));

        insert($con,selectbox($lst,                  array("name"=>"userid")));
        insert($con,hidden(array("name"=>"action","value"=>"addusertogroup")));
        insert($con,hidden(array("name"=>"grp","value"=>"$group")));
        insert($con,submit(array("value"=>my_("Add User"))));


        // Edit users assigned to the group.

        insert($w, generic("br"));
        insert($w, generic("hr"));
        insert($w, block("<b> Group Members</b><br>"));

        insert($w,$t = table(array("cols"=>"2",
                        "class"=>"outputtable")));
        // draw heading
        setdefault("cell",array("class"=>"heading"));
        //insert($t,$c = cell());
        //insert($c,text(my_("Group name")));
        insert($t,$c = cell());
        insert($c,text(my_("Username")));
        insert($t,$c = cell());
        insert($c,text(my_("Action")));

        $result=&$ds->ds->Execute("SELECT * FROM usergrp WHERE grp=".$ds->ds->qstr($group));


        $lst=array();

        while($row = $result->FetchRow()) {
            $col=$row["userid"];
            $lst["$col"]=$row["userid"];
        }

        if (empty($lst)) {
            insert($t, $c = cell());
            insert($c, block("<b>There are no users in this group.</b>"));

        }
        else {
            $icecream=0;
            foreach($lst as $u) {
                setdefault("cell",array("class"=>color_flip_flop()));
                $icecream++;
                insert($t,$c=cell());
                insert($c,block("$u"));
                insert($t,$c=cell());

                insert($c,$f= form(array("name"=>"userkill$icecream","method"=>"post","action"=>$_SERVER["PHP_SELF"]))); 
                insert($f,hidden(array("name"=>"group","value"=>"$g")));
                insert($f,hidden(array("name"=>"action","value"=>"deleteuserfromgroup")));
                insert($f,hidden(array("name"=>"usergrp"   ,"value"=>"$u")));
                insert($f,hidden(array("name"=>"group"   ,"value"=>"$group")));
                // insert($f,submit(array("value"=>"Remove")));
                insert($c,block("<a href='#' onclick='userkill$icecream.submit();'> Remove From Group</a>"));


            }

            //
            //	insert($grpt,$c = cell(array("valign"=>"center")));
            //	insert($c,$f= form(array("method"=>"post","action"=>$_SERVER["PHP_SELF"])));
            //	insert($f,selectbox($lst,array("name"=>"group")));
            //	insert($f,hidden(array("name"=>"action","value"=>"deleteuserfromgroup")));
            //      insert($f,hidden(array("name"=>"usergrp"   ,"value"=>"$user")));
            //      insert($f,hidden(array("name"=>"group"   ,"value"=>"$g")));
            //      insert($f,submit(array("value"=>"Remove User From Group")));
        }

    }

    // Ok.  How bout adding bounds to the group???
    insert($w, $f2 = form(array("name"=>"ENTRY",
                    "method"=>"post",
                    "action"=>$_SERVER["PHP_SELF"])));

    insert($f2, $con=container("fieldset",array("class"=>"fieldset")));
    insert($con, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Add authority bounds to group")));


    insert($con,hidden(array("name"=>"grp","value"=>"$group")));
    insert($con,hidden(array("name"=>"action","value"=>"addgroupboundary")));

    insert($con,text(my_("Authority boundary start address")));

    insert($con,input_text(array("name"=>"ipaddr",
                    "value"=>"$ipaddr",
                    "size"=>"15",
                    "maxlength"=>"15")));
    insert($con,generic("br"));
    insert($con,textbrbr(my_("Authority size/mask")));

    insert($con,selectbox(array("4"=>"255.255.255.252/30 - 4 hosts",
                    "8"=>"255.255.255.248/29 - 8 hosts",
                    "16"=>"255.255.255.240/28 - 16 hosts",
                    "32"=>"255.255.255.224/27 - 32 hosts",
                    "64"=>"255.255.255.192/26 - 64 hosts",
                    "128"=>"255.255.255.128/25 - 128 hosts",
                    "256"=>"255.255.255.0/24 - 256 hosts (class C)",
                    "512"=>"255.255.254.0/23 - 512 hosts",
                    "1024"=>"255.255.252.0/22 - 1k hosts",
                    "2048"=>"255.255.248.0/21 - 2k hosts",
                    "4096"=>"255.255.240.0/20 - 4k hosts",
                    "8192"=>"255.255.224.0/19 - 8k hosts",
                    "16384"=>"255.255.192.0/18 - 16k hosts",
                    "32768"=>"255.255.128.0/17 - 32k hosts",
                    "65536"=>"255.255.0.0/16 - 64k hosts (class B)",
                    "16777216"=>"255.0.0.0/8 - 16m hosts (class A)"),
                array("name"=>"size"),
                $size));

    insert($con,generic("br"));
    insert($con,submit(array("value"=>my_("Submit"))));
    insert($con, generic("hr"));
    $where="WHERE grp=".$ds->ds->qstr($group);

    $result=&$ds->ds->Execute("SELECT boundsaddr, boundssize, grp
            FROM bounds
            $where
            ORDER BY grp, boundsaddr");

        insert($con,heading(3, $title));

        // create a table
        insert($con,$t = table(array("cols"=>"3",
                        "class"=>"outputtable")));
        // draw heading
        setdefault("cell",array("class"=>"heading"));
        //insert($t,$c = cell());
        //insert($c,text(my_("Group name")));
        insert($t,$c = cell());
        insert($c,text(my_("Boundary address")));
        insert($t,$c = cell());
        insert($c,text(my_("Boundary mask")));
        insert($t,$c = cell());
        insert($c,text(my_("Group action")));

        $cnt=0;
        while($row = $result->FetchRow()) {
            setdefault("cell",array("class"=>color_flip_flop()));

            //   insert($t,$c = cell());
            //   if ($savegrp!=$row["grp"]) {
            //      insert($c,text($row["grp"]));
            //   }

            insert($t,$c = cell());
            insert($c,text(inet_ntoa($row["boundsaddr"])));

            insert($t,$c = cell());
            insert($c,text(inet_ntoa(inet_aton(ALLNETS)+1 -
                            $row["boundssize"])."/".inet_bits($row["boundssize"])));

            insert($t,$c = cell());
            insert($c,block("<small>"));
            insert($c,anchor("deletebounds.php?grp=".urlencode($row["grp"]).
                        "&boundsaddr=".$row["boundsaddr"],
                        my_("Delete boundary"),
                        $ipplanParanoid ? array("onclick"=>"return confirm('".my_("Are you sure?")."')") : FALSE));
            insert($c,block("</small>"));

            $cnt++;
            $savegrp=$row["grp"];
        }

        insert($con,block("<p><b>".sprintf(my_("Total records: %u"), $cnt)."</b>"));

}


function insertCreateUserForm($w,$ds) {

    insert($w, $f = form(array("method"=>"post",
                    "action"=>$_SERVER["PHP_SELF"])));
    insert($f,hidden(array("name"=>"action","value"=>"parsecreateuserform")));

    insert($f, $con=container("fieldset",array("class"=>"fieldset")));
    insert($con, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Create new user")));

    insert($con,textbr(my_("User-id (case sensitive!):")));
    insert($con,input_text(array("name"=>"userid",
                    "value"=>"$userid",
                    "size"=>"20",
                    "maxlength"=>"40")));
    insert($con,textbrbr(my_("User's fullname:")));
    insert($con,input_text(array("name"=>"userdescrip",
                    "value"=>"$userdescrip",
                    "size"=>"40",
                    "maxlength"=>"80")));
    if (AUTH_INTERNAL) {
        insert($con,textbrbr(my_("Password (case sensitive!):")));
        insert($con,password(array("name"=>"password1",
                        "value"=>"$password1",
                        "size"=>"20",
                        "maxlength"=>"40")));
        insert($con,textbrbr(my_("Password (again):")));
        insert($con,password(array("name"=>"password2",
                        "value"=>"$password2",
                        "size"=>"20",
                        "maxlength"=>"40")));
    }

    //insert($f,block("</td></tr></table>"));

    $result2=$ds->GetGrps();

    $lst=array(""=>"No group");
    while($row = $result2->FetchRow()) {
        $col=$row["grp"];
        $lst["$col"]=$row["grp"]." - ".$row["grpdescrip"];
    }
    insert($con,textbrbr(my_("Group")));
    insert($con,selectbox($lst,
                array("name"=>"grp")));

    insert($f,submit(array("value"=>my_("Create User"))));
    insert($f,freset(array("value"=>my_("Clear"))));

}


function parseCreateUserForm($w,$ds) {
    $userid      = $_POST["userid"];
    $userdescrip = $_POST["userdescrip"];
    $password1   = $_POST["password1"];
    $password2   = $_POST["password2"];
    $grp		= $_POST["grp"];
    insert($w,block("<h3> Creating User....</h3>"));
    $userid=trim($userid);
    $userdescrip=trim($userdescrip);
    $search=trim($search);
    if (AUTH_INTERNAL) {
        $password1=trim($password1);
        $password2=trim($password2);
    }
    else {
        // generate random password in case user changes authentication
        // from external to internal at some point
        $password1=$password2=rand(10000, 1000000);
    }

    if (strlen($userid) < 2) {
        $formerror .= my_("The user-id must be longer")."\n";
    }
    if (strlen($userdescrip) < 2) {
        $formerror .= my_("The user description must be longer")."\n";
    }
    if (strlen($password1) < 5 or strlen($password2) < 5) {
        $formerror .= my_("The password entered must be at least five characters")."\n";
    }
    if ($password1 != $password2) {
        $formerror .= my_("The passwords entered do not match")."\n";
    }
    if (!$formerror) {
        $password=crypt($password1, 'xq');

        $ds->DbfTransactionStart();
        // emulates mysql REPLACE
        $result=&$ds->ds->Execute("DELETE FROM users
                WHERE userid=".$ds->ds->qstr($userid));
        $result=&$ds->ds->Execute("INSERT INTO users
                (userid, userdescrip, password)
                VALUES
                (".$ds->ds->qstr($userid).",
                 ".$ds->ds->qstr($userdescrip).",
                 ".$ds->ds->qstr($password).")");

        // add group if user selected a group other than "No group"
        if (!empty($grp)) {
            $result=&$ds->ds->Execute("DELETE FROM usergrp
                    WHERE userid=".$ds->ds->qstr($userid)." AND
                    grp=".$ds->ds->qstr($grp));
            $result=&$ds->ds->Execute("INSERT INTO usergrp
                    (userid, grp)
                    VALUES
                    (".$ds->ds->qstr($userid).",
                     ".$ds->ds->qstr($grp).")");
        }

        if ($result) {
            $ds->DbfTransactionEnd();

            if ($ds->ds->Affected_Rows() == 2)
                insert($w,text(my_("Existing user overwritten")));
            else
                insert($w,text(my_("User created")));
        }
        else {
            $formerror .= my_("User could not be created")."\n";
        }
    }
    return($formerror);

}

function parseCreateGroupForm($w,$ds) {
    $grp=$_POST["grp"];
    $grpdescrip=$_POST["grpdescrip"];
    $createcust=$_POST["createcust"];
    $grpview=$_POST["grpview"];
    $grp=trim($grp);
    $grpdescrip=trim($grpdescrip);

    if (strlen($grp) < 2) {
        $formerror .= my_("The group name must be longer")."\n";
    }
    if (strlen($grpdescrip) < 2) {
        $formerror .= my_("The group description must be longer")."\n";
    }
    if (ereg("[^[:alnum:]-]", $grp)) {
        $formerror .= my_("Only numbers and digits are allowed in the group name")."\n";
    }

    if (!$formerror) {
        $ds->DbfTransactionStart();

        // grpopt is a bit encoded field which will contain true/false type
        // options on groups - currently only one bit is used to define if
        // customers can view others data

        // bit 1 : 1 = user can view all customers info
        //         0 = user can view only groups customers
        $grpbit=0;
        if($grpview=="Y") {
            $grpbit=1;
        }

        $result=&$ds->ds->Execute("INSERT INTO grp
                (grp, createcust, grpdescrip, grpopt)
                VALUES
                (".$ds->ds->qstr($grp).",
                 ".$ds->ds->qstr($createcust).",
                 ".$ds->ds->qstr($grpdescrip).",
                 ".$grpbit.")");

        if ($result) {
            $ds->DbfTransactionEnd();
            insert($w,textbr(my_("Group created")));
        }
        else {
            $ds->DbfTransactionRollback();
            $formerror .= my_("Group could not be created - possibly a duplicate")."\n";
        }
    }
    return($formerror);
}

function parseDeleteForms($w, $ds) {

    // NOTE: don't change order of if's!!!

    // Ah yes, defintely not changing order...  -- Stephen

    // 2-8-2005 Fixed code so that it will use myError() by returning a form error.

    $user    = $_POST["user"];
    $usergrp = $_POST["usergrp"];
    $grp     = $_POST["group"];
    $fe="";

    // delete a user
    if ($user) {
        $ds->DbfTransactionStart();
        $result=&$ds->ds->Execute("DELETE FROM users
                WHERE userid=".$ds->ds->qstr($user)) and
            $result=&$ds->ds->Execute("DELETE FROM usergrp
                    WHERE userid=".$ds->ds->qstr($user));

        if ($result) {
            $ds->DbfTransactionEnd();
            insert($w,text(my_("User $user deleted")));
        }
        else {
            $fe .=my_("User could not be deleted");
        }
    }
    // delete user from group
    else if ($usergrp) {

        $user=$usergrp;

        $ds->DbfTransactionStart();
        $result=&$ds->ds->Execute("DELETE FROM usergrp
                WHERE userid=".$ds->ds->qstr($user)." AND
                grp=".$ds->ds->qstr($grp));

        if ($result) {
            $ds->DbfTransactionEnd();
            insert($w,text(my_("User $user deleted from group")));
        }
        else {
            $fe .=my_("User could not be deleted from group");
        }

    }
    else if ($grp and !$usergrp) {
        // check if grp has customers
        $result=&$ds->ds->Execute("SELECT custdescrip
                FROM customer
                WHERE admingrp=".$ds->ds->qstr($grp));
        if ($row=$result->FetchRow()) {
            $fe .=my_("Cannot delete group because the following customers are assigned to the group:");
            do {
                $fe .= $row["custdescrip"];
            } while($row=$result->FetchRow());

        }

        // check if grp has subnets
        $result=&$ds->ds->Execute("SELECT baseaddr, descrip
                FROM base
                WHERE admingrp=".$ds->ds->qstr($grp)."
                ORDER BY baseaddr");
        if ($row=$result->FetchRow()) {
            $fe .= my_("Cannot delete group because the following subnets are assigned to the group:");

            do {
                $fe .= inet_ntoa($row["baseaddr"])." - ".$row["descrip"];
            } while($row = $result->FetchRow());

        }

        $ds->DbfTransactionStart();
        $result=&$ds->ds->Execute("DELETE FROM grp
                WHERE grp=".$ds->ds->qstr($grp)) and
            $result=&$ds->ds->Execute("DELETE FROM usergrp
                    WHERE grp=".$ds->ds->qstr($grp)) and
            $result=&$ds->ds->Execute("DELETE FROM bounds
                    WHERE grp=".$ds->ds->qstr($grp));

        if ($result) {
            $ds->DbfTransactionEnd();
            insert($w,text(my_("Group $grp deleted")));
        }
        else {
            $fe .= my_("Group could not be deleted");
        }
    } // endif

} // end function


function parseChangeUserPassword($w, $ds) {
    $password1=trim($_POST["password1"]);
    $password2=trim($_POST["password2"]);
    $userid=$_POST["user"];
    if (strlen($password1) < 5 or strlen($password2) < 5) {
        $formerror .= my_("The password entered must be at least five characters")."\n";
    }

    if ($password1 != $password2) {
        $formerror .= my_("The passwords entered do not match")."\n";
    }


    $password=crypt($password1, 'xq');

    $ds->DbfTransactionStart();
    $result=&$ds->ds->Execute("UPDATE users
            SET password=".$ds->ds->qstr($password)."
            WHERE userid=".$ds->ds->qstr($userid));
    $ds->AuditLog(sprintf(my_("User %s changed password"), $userid));

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,text(my_("Password changed")));
    }
    else {
        $formerror .= my_("Password could not be changed")."\n";
    }
    return($formerror);
}


function parseAddUserToGroupForm($w, $ds) {
    $userid=$_POST["userid"];
    $grp=$_POST["grp"];

    $ds->DbfTransactionStart();
    // emulate mysql REPLACE
    $result=&$ds->ds->Execute("DELETE FROM usergrp
            WHERE userid=".$ds->ds->qstr($userid)." AND
            grp=".$ds->ds->qstr($grp));
    $result=&$ds->ds->Execute("INSERT INTO usergrp
            (userid, grp)
            VALUES
            (".$ds->ds->qstr($userid).",
             ".$ds->ds->qstr($grp).")");

    if ($result) {
        $ds->DbfTransactionEnd();
        insert($w,textbr(my_("User added to group")));
    }
    else {
        $formerror .= my_("User could not be added to group")."\n";
    }
    return $formerror;
}

function parseModifyGroupForm($w, $ds) {
    $grpdescrip=$_POST["grpdescrip"];
    $grp       =$_POST["grp"];
    $grpview   =$_POST["grpview"];
    $createcust=$_POST["createcust"];
    $grpdescrip=trim($grpdescrip);
    if (strlen($grpdescrip) < 2) {
        $formerror .= my_("The group description must be longer")."\n";
    }

    if (!$formerror) {

        $ds->DbfTransactionStart();

        // grpopt is a bit encoded field which will contain true/false type
        // options on groups - currently only one bit is used to define if
        // customers can view others data
        $grpbit=0;
        if($grpview=="Y") {
            $grpbit=1;
        }


        $result=&$ds->ds->Execute("UPDATE grp
                SET grpdescrip=".$ds->ds->qstr($grpdescrip).",
                createcust=".$ds->ds->qstr($createcust).",
                grpopt=".$grpbit."
                WHERE grp=".$ds->ds->qstr($grp));

        if ($result) {
            $ds->DbfTransactionEnd();
            insert($w,text(my_("Group $grp details modified")));
        }
        else {
            $formerror .= my_("Group details could not be modified")."\n";
        }
    }

}

function parseAddGroupBoundaryForm($w, $ds) {
    $grp = $_POST["grp"];
    $ipaddr = $_POST["ipaddr"];
    $size = $_POST["size"];
    // explicitly cast variables as security measure against SQL injection
    $formerror="";
    $size=floor($size);

    if ($_POST) {

        $base=inet_aton($ipaddr);

        if (!$ipaddr)
            $formerror .= my_("Boundary address may not be blank")."\n";
        else if (testIP($ipaddr))
            $formerror .= my_("Invalid boundary address")."\n";
        else if (!$size)
            $formerror .= my_("Size may not be zero")."\n";
        else if (TestDuplicateBounds($ds, $base, $size, $grp))
            $formerror .= my_("Boundary cannot be created - overlaps with existing boundary")."\n";

        if ($size > 1) {
            if (TestBaseAddr(inet_aton3($ipaddr), $size)) {
                $formerror .= my_("Invalid base address")."\n";
            }
        }

        if (!$formerror) {
            $ds->DbfTransactionStart();

            // the fact that the range is unique prevents the range
            // being added to more than one area!
            $result=&$ds->ds->Execute("INSERT INTO bounds
                    (boundsaddr, boundssize, grp)
                    VALUES
                    ($base, $size, ".$ds->ds->qstr($grp).")");

            if ($result) {
                $ds->DbfTransactionEnd();
                insert($w,textbr(my_("Boundary created")));
            }
            else {
                $formerror .= my_("Boundary could not be created")."\n";
            }
        }
    }
    return($formerror);
}

function TestDuplicateBounds($ds, $boundsaddr, $boundssize, $grp) {

    $result=&$ds->ds->Execute("SELECT boundsaddr
            FROM bounds
            WHERE (($boundsaddr BETWEEN boundsaddr AND
                    boundsaddr + boundssize - 1) OR
                ($boundsaddr < boundsaddr AND
                 $boundsaddr+$boundssize >
                 boundsaddr + boundssize - 1)) AND
            grp=".$ds->ds->qstr($grp));

    if ($result->FetchRow()) {
        return 1;
    }
}

?>
